<html lang="en">
<head>
<title>Precompiled DTD Subsets - psgml</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="psgml">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="up" href="Managing-the-DTD.html#Managing-the-DTD" title="Managing the DTD">
<link rel="prev" href="Managing-the-DTD.html#Managing-the-DTD" title="Managing the DTD">
<link rel="next" href="Using-a-Split-Document.html#Using-a-Split-Document" title="Using a Split Document">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Precompiled-DTD-Subsets"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Using-a-Split-Document.html#Using-a-Split-Document">Using a Split Document</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Managing-the-DTD.html#Managing-the-DTD">Managing the DTD</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="Managing-the-DTD.html#Managing-the-DTD">Managing the DTD</a>
<hr>
</div>

<!-- node-name,  next,  previous,  up -->
<h3 class="section">7.1 Precompiled DTD Subsets</h3>

<p>If parsing the DTD takes too long time you can arrange to have PSGML
cache an internal complied version of the DTD.  Caching can be done of
DTD fragments in favourable situations.  It is possible to have an
external DTD subset cached but still have an internal DTD subset as long
as the internal subset does not define parameter entities that affect
the parsing of the external subset (*** what is the exact conditions?,
probably you can't use the cached external subset if the internal subset
defines parameter entities that are also defined in the external subset
with another value).

   <p><a name="index-sgml_002decat_002dfiles-38"></a><a name="index-sgml_002dlocal_002decat_002dfiles-39"></a>To enable caching you have to create special catalog files, hereafter
called ECAT files due to (temporary) lack of imagination.  These catalogs
have similar syntax to the entity catalogs and there are two variables
containing lists of catalogs to search: <code>sgml-ecat-files</code> and
<code>sgml-local-ecat-files</code>.  The ECAT files can contain the following
types of entries:

     <dl>
<dt>`<samp><span class="samp">file </span><var>dtdfile</var> <var>entitydef</var> <var>cfile</var></samp>'<dd>The <var>dtdfile</var> is the name of a file containing a DTD subset that
should be cached in <var>cfile</var>.  The <var>entitydef</var> is optional and if
given have the following syntax:
     <pre class="example">          [ <var>name1</var> <var>literal1</var> <var>name2</var> <var>literal2</var> ... ]
     </pre>
     <p>Using <var>entitydef</var> will modify the DTD subset by defining the
parameter entity with name <var>name1</var> to be <var>literal1</var>, <small class="dots">...</small>.  The
cached version of the subset will be created with those entity
definitions, and when PSGML search for a matching cached subset will check
that the parameter entities in <var>entitydef</var> has been defined with
those values before trying to use <samp><span class="file">cfile</span></samp>.

     <br><dt>`<samp><span class="samp">public </span><var>pubid</var> <var>entitydef</var> <var>cfile</var></samp>'<dd>Cache the DTD subset with public identifier <var>pubid</var> in file
<var>cfile</var>. 
</dl>

<div class="defun">
&mdash; User Option: <b>sgml-recompile-out-of-date-cdtd</b><var><a name="index-sgml_002drecompile_002dout_002dof_002ddate_002dcdtd-40"></a></var><br>
<blockquote><p>If non-<code>nil</code>, out of date compiled DTDs will be automatically
recompiled.  If the value is <code>ask</code>, PSGML will ask before
recompiling.  A <code>nil</code> value will cause PSGML to silently load an out
of date compiled DTD.  A DTD that refers to undefined external entities
is always out of date, thus in such case it can be useful to set this
variable to <code>nil</code>. 
</p></blockquote></div>

   <p>Previous versions of PSGML have had another way of speeding up DTD
parsing.  This code remains in this version of PSGML, but is not actively
maintained and may disappear in the future.

   <p><a name="index-sgml_002dsave_002ddtd-41"></a><a name="index-sgml_002dload_002ddtd-42"></a><a name="index-sgml_002ddefault_002ddtd_002dfile-43"></a>You can save the parsed DTD in a file using the command <kbd>M-x
sgml-save-dtd</kbd>.  Next time PSGML can load that file instead of parsing
the DTD.  For PSGML to find the saved DTD you must either save the DTD
using the default name or do a <kbd>M-x sgml-save-options</kbd> after saving
the DTD.  To directly use an already parsed and saved DTD, load the file
containing the saved DTD with the command <kbd>M-x sgml-load-dtd</kbd>.

<div class="defun">
&mdash; User Option: <b>sgml-default-dtd-file</b><var><a name="index-sgml_002ddefault_002ddtd_002dfile-44"></a></var><br>
<blockquote><p>This is the default file name for saved DTD.  This is set by
<code>sgml-mode</code> to the buffer file name less extension plus the
extension <code>.ced</code>, if that file exists.  Can be changed in the Local
variables section of the file. 
</p></blockquote></div>

<!-- true with system-path -->
<!-- either or by creating a saved DTD and setting -->
<!-- @code{sgml-default-dtd-file} to that file.  If -->
<!-- @code{sgml-default-dtd-file} contains a relative file name, the -->
<!-- directories in @code{sgml-system-path} will be searched for the file. -->
<!--  -->
</body></html>

